menu_is_open = false
menu_stack = {}
menu_stack_index = -1
option_render_index = 0
option_selected_index = 0

function draw_text(text, x, y, scale, font, r, g, b, outline)
  natives.set_text_font(font)
  natives.set_text_centre(false)
  natives.set_text_right_justify(false)
  natives.set_text_colour(r, g, b, a)
  natives.set_text_scale(0.0, scale)
  natives.set_text_wrap(0.0, 1.0)
  if outline then natives.set_text_outline() end
  natives.begin_text_command_display_text("STRING")
  natives.add_text_component_substring_player_name(text)
  natives.end_text_command_display_text(x, y, 0)
end

function option(name, pressed, on_click)
  if option_selected_index == option_render_index then
    if on_click ~= nil and pressed then
      on_click()
    end
    draw_text(name, 0.1, 0.1 + (option_render_index * 0.03), 0.35, 0, 255, 255, 0, 255, false)
  else
    draw_text(name, 0.1, 0.1 + (option_render_index * 0.03), 0.35, 0, 255, 255, 255, 255, false)
  end
  option_render_index = option_render_index + 1
end

function menu_option(name, pressed, new_menu)
  if option_selected_index == option_render_index then
    if new_menu ~= nil and pressed then
      menu_stack[menu_stack_index + 1] = new_menu
      menu_stack_index = menu_stack_index + 1
    end
    draw_text(name, 0.1, 0.1 + (option_render_index * 0.03), 0.35, 0, 255, 255, 0, 255, false)
  else
    draw_text(name, 0.1, 0.1 + (option_render_index * 0.03), 0.35, 0, 255, 255, 255, 255, false)
  end
  option_render_index = option_render_index + 1
end

menu_root = function(p)
  menu_option("Test", p, function(p)
    -- options within Test
    option("Send Chat Test", p, function()
      rage.send_global_chat("Hello World", 1, true, false)
    end)
    -- Test end
  end)
  menu_option("Network", p, function(p)
    -- options within Network
    menu_option("Players", p, function(p)
      -- options within Players
      for i = 0, 32, 1 do
        if natives.network_is_player_connected(i) then
          option(natives.get_player_name(i), p, function()
            utility.print_info("You have selected player " .. natives.get_player_name(i))
          end)
        end
      end
      -- Players end
    end)
    -- Network end
  end)
end

menu_stack[menu_stack_index + 1] = menu_root
menu_stack_index = menu_stack_index + 1

while true do
  if menu_is_open then
    if menu_stack[menu_stack_index] ~= nil then
      natives.set_input_exclusive(0, 172)
      natives.set_input_exclusive(0, 173)
      natives.set_input_exclusive(0, 176)
      natives.set_input_exclusive(0, 177)
      menu_stack[menu_stack_index](natives.is_control_just_pressed(0, 176))
      if natives.is_control_just_pressed(0, 172) then
        option_selected_index = option_selected_index - 1
      end
      if natives.is_control_just_pressed(0, 173) then
        option_selected_index = option_selected_index + 1
      end
      if natives.is_control_just_pressed(0, 177) then
        if menu_stack_index ~= 0 then
          menu_stack_index = menu_stack_index - 1
        end
      end
    end
  end
  if natives.is_control_just_pressed(0, 313) then
    menu_is_open = not menu_is_open --[[']' or DPAD RIGHT]]
  end
  if option_selected_index < 0 then
    option_selected_index = option_render_index - 1
  end
  if option_selected_index >= option_render_index then
    option_selected_index = 0
  end
  natives.draw_rect(0.1 + (0.2 * 0.5) - 0.002, 0.1 + ((option_render_index * 0.03) * 0.5) - 0.002, 0.2, (option_render_index * 0.03), 0, 0, 0, 170, 0)
  option_render_index = 0
  sys.yield()
end